#!/usr/bin/python
#Ubuntu Server Manager
#Copyright (C) 2007 usmteam
#
#This file is part of Ubuntu Server Manager 
#
#This program is free software; you can redistribute it and/or
#modify it under the terms of the GNU General Public License
#as published by the Free Software Foundation; either version 2
#of the License, or (at your option) any later version.
#
#This program is distributed in the hope that it will be useful,
#but WITHOUT ANY WARRANTY; without even the implied warranty of
#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#GNU General Public License for more details.
#
#You should have received a copy of the GNU General Public License
#along with this program; if not, write to the Free Software
#Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

import xml.dom.minidom 
import cgitb; cgitb.enable()
import sys
import os
import commands
import cgi

import xmlconfighandler
from lib_plugins import plugins

def plugin(web_page,form):
	htmout=""
	if web_page["page"]=="shares":
		doc = interface(web_page,"shares")
		htmout+=doc.index(form)
	return htmout

class interface(plugins):
	def __init__(self,web_page,pagename):
		plugins.__init__(self,web_page,pagename) 	#run __init__ method from plugins class instead of overridding
		self.load_config_file(self.profilepath + "/samba/","customshares.xml","shares")
		self.pluginpath=self.pluginpath+"samba/"
		self.pluginfilename="usm_samba"
		self.logpath="/var/log/samba/"
		self.sharespath = "/home/server/shares/"

		#xml description,tag,config parameter,value
		self.tagname1 = "hostname"
		self.config1 	= 	[['hostname','netbios','    netbios name = ','dot-server','',''],
		                	['workgroup/domain','workgroup','    workgroup = ','workgroup','',''],
							['samba role','role','    security = ','','',''],
							['Shared Data','datapath','    path = ','','','']]
							
		self.tagname2 = "hostname"
		self.config2 	= 	[['samba role','role','    security = ','','',''],
		              	  	['master browser','preferedmaster','    prefered master = ','','',''],
		              	  	['','localmaster','    local master = ','','',''],
		              	  	['','domainmaster','    domain master = ','','','']]

		self.tagname3 	= "share"
		self.config3	= 	[['share name','name','[','',']',['textbox','']],
	                      	['local path','path','    path = ','','',['hidden','']],
	                    	['share comments','comment','    comment = ','test comments','',['textbox','']],
	                    	['browsable on network','browseable','    browseable = ','yes','',['combobox','yes::::no']],
	                    	['writable','writable','    writable = ','no','',['combobox','no::no::::everyone::everyone::::list::Restricted List']],
	                    	['readable','readable','    readable = ','nobody','',['combobox','everyone::everyone::::list::Restricted List']],
	                    	['Write List','write_list','    write list = ','yes','',['textbox','nobody']],
	                    	['Read List','read_list','    read list = ','','',['textbox','nobody']]] 

	def index(self,form):
		filecheck=0
		filecheck+=self.check_file(self.profilepath + "/server/hostname.xml")
		htmout=""
		if filecheck==0:
			htmout+=plugins.index(self,form)
			if self.web_page["subpage"]=="form":
				htmout+=self.page_form_gen(self.tagname3,self.config3,"save","Edit / Add Shares Network Folders") 
			if self.web_page["subpage"]=="del":
				htmout+=self.del_share(self.web_page["name"])
				htmout+=self.page_default()
			if self.web_page["subpage"]=="save":
				htmout+=self.save_form_gen(form,self.tagname3,self.config3)	
				htmout+=self.page_default()
			if self.web_page["subpage"]=="restart":
				htmout+=self.generateconfig()
		else:
			htmout+=self.web.traffic_lights("amber","Missing Configuration Files","Check you have configured this servers primary settings.")
		return htmout

	def get_logfiles(self):
		for fname in os.listdir(self.logpath):
			if not os.path.isdir(fname):
				try:
					print 
					if fname[0:4]=="log.":
						if not fname.endswith(".gz"):
							self.logfiles.append(fname)
				except:
					pass

	def del_share(self, name):
		htmout = ""
		print "remove name="+str(self.web_page["name"])
		self.doc.tagname = "share"
		self.doc.config = self.config3
		self.doc = xmlconfighandler.xmlHandler(self.profilepath + "/samba/customshares.xml","share")

		print "remove name="+name
		print self.doc.removeElement(self.web_page["name"])
		return htmout


	def page_default(self):
		style=""
		self.load_config_file(self.profilepath + "/samba/","customshares.xml","shares")

		
		tbar=self.web.tool_icon("index.py?Page="+self.pagename+"&amp;SubPage=help","images/icons/tango/32x32/apps/help-browser.png","<b>Action: Help</b><br><i>Description: Help Documentation for this plugin module.</i>")
		tbar+=self.web.tool_icon("index.py?Page="+self.pagename+"&amp;SubPage=form","images/icons/tango/32x32/places/folder-remote.png","<b>Action: New Share</b><br><i>Description: Add New Shared Folder</i>")
		tbar+=self.web.tool_icon("index.py?Page="+self.pagename+"&amp;SubPage=formglobal","images/icons/tango/32x32/categories/preferences-desktop.png","<b>Action: Main Settings</b><br><i>Description: Change Main Folder Shareing Settings</i>")
		tbar+=self.web.tool_icon("index.py?Page="+self.pagename+"&amp;SubPage=log","images/icons/tango/32x32/categories/preferences-desktop.png","<b>Action: Log files</b><br><i>Description: View your samba log files.</i>")
		tbar+=self.web.tool_icon("index.py?Page="+self.pagename+"&amp;SubPage=restart","images/icons/tango/32x32/actions/view-refresh.png","<b>Action: Restart</b><br><i>Description: Restart samba service</i>")
		htmout=self.web.tool_bar("Shared Network Folders Configuration",tbar)
		count = 1

		htmout+="<br /><table class=\"tab\" ><tr class=\"tabtitle\"><td colspan=\"5\" >Shared Network Folders</td></tr>"
		htmout+="<tr class=\"tabhead\"><td>id</td><td>Folder</td><td>Path</td><td>Comments</td><td>Modify</td><tr>"
		self.set_config(self.config3,self.tagname3)
		shares = self.doc.getTagAttrib(self.tagname3,"name")
		print shares
		for share in shares:
			style=self.web.switch_style(style,"tabrow1","tabrow2")
			self.doc.getElement(str(share))
			htmout+="<tr class=\""+style+"\"><td >" + str(count) + "</td>"
			htmout+="<td><a href=\"index.py?Page=Shares&amp;SubPage=form&amp;name="+ str(share) +"\">" + str(share) + "</a></td>"
			htmout+="<td>" + self.doc.config[1][3] + "</td>"
			htmout+="<td>" + self.doc.config[2][3] + "</td>"
			htmout+="<td>"
			htmout+=self.web.but_img("index.py?Page="+self.pagename+"&amp;SubPage=form&amp;name="+ str(share),"/images/icons/silk/icons/table_edit.png","Edit")
			htmout+=self.web.but_img("index.py?Page="+self.pagename+"&amp;SubPage=del&amp;name="+ str(share),"/images/icons/silk/icons/delete.png","Del")
			htmout+="</td></tr>"
			count=count+1
		htmout+="<tr><td colspan=\"4\">"
		htmout =htmout + "</td></tr>"
		htmout+="</table>"

		return htmout
		
	def save(self, form):
		self.doc.tagname = "share"
		#self.doc = xmlconfighandler.xmlHandler(os.path.abspath('') + "/config/samba/customshares.xml","share")
		self.doc.config = self.config3

		htmout = ""
		print "save test"

		for share in self.doc.config:
			try:
				share[3] = form[share[1]][0].lower()
			except:
				share[3] = ""

		self.doc.config[1][3]=self.sharespath+form[self.doc.config[0][1]][0]
		print self.doc.config


		self.doc.insertElement()

		htmout+="Updated Samba Shares Config Files"

		command1="mkdir "+str(self.doc.config[1][3])
		errors1=lib_custom.BashComm(command1)

		command2="chmod -R 777 "+str(self.doc.config[1][3])
		errors2=lib_custom.BashComm(command2)

		errors="0"
		print "----------------------------------"+str(errors1)+"----------"
		if errors1[0]!="0":
			if errors1[0:12]=="error := 256":
				print "error=============================="
			errors="1"
		if errors2[0]!="0":
			errors="1"

		htmout+=""
		if errors == "0":
			htmout+="<div class=\"success\">Success.....<br />"
			htmout+="Created Group Account....<br />"
			htmout+="Executing "+command1+"<br \>"
		else:
			htmout+="<div class=\"failure\">Failed with these Errors...."
			htmout+="Executing.....<br />"
			htmout+="Executing "+command1+"<br \>"
			htmout+=errors1+"<br \>"
		htmout+="</div><br />"

		return htmout

	def config(self):
		htmout= self.doc.readDocument()
		return htmout

	def getshares(self):
		useraccounts = open('/etc/samba/smb.conf')
		for line in useraccounts.readlines():
			line2=str(line)
			try:
				curuser = line2.split("[")[1].split("]")[0]
				if curuser=="profiles":
					print "hidename========"+str(curuser)
				else:
					print "name========"+str(curuser)
			except:
				curuser = ""
		return ""

	def generateconfig(self):
		#print self.path
		hostname=commands.getstatusoutput("hostname")[1]
		self.load_config_file(self.profilepath + "/server/","hostname.xml","hostname")
		self.set_config(self.config1,self.tagname1)
		self.doc.getElement(hostname)	
		
		smbconf="[global]\n"
		smbconf+="###########################################\n"
		smbconf+="## Server (hostname, domains)\n"
		smbconf+="###########################################\n"
		smbconf+="netbios name = "+self.doc.config[0][3]+"\n"
		smbconf+="workgroup ="+self.doc.config[1][3]+"\n"

		smbconf+="###########################################\n"
		smbconf+="## Samba Role\n"
		smbconf+="###########################################\n"
		self.doc.getTagAttrib(self.tagname1,"name")

		if self.doc.config[2][3].lower()=="pdc":
			smbconf+="\tsecurity = users\n"
			smbconf+="\tpreferred master = yes\n"
			smbconf+="\tdomain master = yes\n"
			smbconf+="\tlocal master = yes\n"
			smbconf+="\tos level = 33\n\n"
		sharespath=self.doc.config[3][3]


		openfile = open(self.profilepath+"/samba/smb.conf", 'r') 
		smbconf = smbconf + "" + openfile.read() + "" 
		openfile.close()

		self.load_config_file(self.profilepath + "/samba/","customshares.xml","shares")
		self.set_config(self.config3,self.tagname3)
		smbconf+="###########################################\n"
		smbconf+="## Samba Custom Shares\n"
		smbconf+="###########################################\n"
		items = self.doc.getTagAttrib(self.tagname3,"name")
		for item  in items:
			self.doc.getElement(item)
			smbconf+="["+item+"]"+"\n"
			smbconf+="path = "+sharespath+self.doc.config[1][3]+"\n"
			smbconf+="comment = "+self.doc.config[2][3]+"\n"
			smbconf+="browseable = "+self.doc.config[4][3]+"\n"

			smbconf+="write list = yes"
			smbconf+="read list = guest"
			if self.doc.config[4][3]=="no":#write
				smbconf+="writable = no\n"	
			if self.doc.config[4][3]=="everyone":#write
				smbconf+="writable = yes\n"
				smbconf+="force user = nobody\n"
				smbconf+="force group = nobody\n"
			if self.doc.config[4][3]=="list":#write
				smbconf+="writable = yes\n"
				smbconf+="write list = "+self.doc.config[6][3]+"\n"
				
			if self.doc.config[5][3]=="everyone":#read
				smbconf+="force user = nobody"+"\n"
				smbconf+="force group = nobody"+"\n"	
			if self.doc.config[5][3]=="list":#read
				smbconf+="read list = "+self.doc.config[6][3]+"\n"				

		self.save_config("/etc/samba/smb.conf",smbconf)
		self.restart_service("samba")
		return smbconf.replace("\n","<br>")
